'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = cards;

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _raf = require('raf');

var _raf2 = _interopRequireDefault(_raf);

var _grid = require('./grid');

var _grid2 = _interopRequireDefault(_grid);

var _column = require('./column/column');

var _column2 = _interopRequireDefault(_column);

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function cards(pure) {
  var React = pure.React,
      PropTypes = pure.PropTypes,
      cloneElement = pure.cloneElement,
      shallowCompare = pure.shallowCompare,
      Immutable = pure.Immutable,
      Pre = pure.Pre,
      formula = pure.formula,
      defaults = pure.defaults;


  var toggleHeight = 50;

  var Grid = (0, _grid2.default)(pure);
  var ZERO_MEASURES = [null, '', 0, '0', '0px', 50 + 'px'];

  return pure({ displayName: 'Cards',
    propTypes: { styles: PropTypes.object.isRequired,
      theme: PropTypes.object.isRequired,
      mapHeader: PropTypes.func.isRequired,
      mapContent: PropTypes.func.isRequired,
      data: PropTypes.object.isRequired,
      transitionDurationMS: PropTypes.number
    },
    defaultProps: (0, _extends3.default)({}, defaults),
    init: function init() {
      this.contents = {};
    },
    render: function render() {
      var _this = this;

      var _props = this.props,
          styles = _props.styles,
          theme = _props.theme,
          className = _props.className,
          mapHeader = _props.mapHeader,
          mapContent = _props.mapContent,
          data = _props.data,
          gridProps = (0, _objectWithoutProperties3.default)(_props, ['styles', 'theme', 'className', 'mapHeader', 'mapContent', 'data']);

      return React.createElement(Grid, (0, _extends3.default)({}, gridProps, {
        data: data,
        className: (0, _classnames2.default)(styles.cards, theme.cards, className),
        templates: { Document: pure.profile({ displayName: 'CardsDocument',
            render: function render(_ref) {
              var documentIndex = _ref.documentIndex,
                  children = _ref.children,
                  props = (0, _objectWithoutProperties3.default)(_ref, ['documentIndex', 'children']);

              return React.createElement(
                'div',
                { className: (0, _classnames2.default)(styles.cardsDocument, theme.cardsDocument) },
                children
              );
            }
          })
        },
        mapDocument: function mapDocument(_ref2) {
          var documentIndex = _ref2.documentIndex,
              documentID = _ref2.documentID,
              datum = _ref2.datum;
          return React.createElement(
            'div',
            { className: (0, _classnames2.default)(styles.card, theme.card) },
            React.createElement(
              'div',
              {
                //onClick={() => this.toggleDocument(documentID)}
                className: (0, _classnames2.default)(styles.cardHeader, theme.cardHeader)
              },
              mapHeader({ documentIndex: documentIndex, documentID: documentID, datum: datum.get('header') })
            ),
            React.createElement(
              'div',
              {
                ref: function ref(x) {
                  return _this.contents[documentID] = x;
                },
                className: (0, _classnames2.default)(styles.cardContent, theme.cardContent)
              },
              mapContent({ documentIndex: documentIndex, documentID: documentID, datum: datum.get('content') })
            )
          );
        }
      }));
    }
  });
}