'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

exports.default = columns;

var _column = require('./column');

var _column2 = _interopRequireDefault(_column);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function columns(pure) {
  var React = pure.React,
      PropTypes = pure.PropTypes,
      cloneElement = pure.cloneElement,
      formula = pure.formula,
      Pre = pure.Pre,
      defaults = pure.defaults;

  var Column = (0, _column2.default)(pure);

  return function Columns(columnIDs) {
    var columnProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    console.warn('COLUMN IDs', columnIDs);
    function reduceColumns(reducer) {
      return columnIDs.reduce(function (reduced, columnID) {
        return (0, _extends4.default)({}, reduced, (0, _defineProperty3.default)({}, columnID, reducer(columnID)));
      }, {});
    }
    var fixedWidths = (0, _values2.default)(columnProps).filter(function (props) {
      return typeof props.width !== 'undefined';
    }).map(function (_ref) {
      var width = _ref.width;
      return width;
    });
    var _columns = reduceColumns(function (columnID) {
      return Column(columnID, columnProps[columnID]);
    }, { fixedWidths: fixedWidths });
    _columns.ids = columnIDs;
    _columns.reduce = reduceColumns;
    return _columns;
  };
}