'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = expander;

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function expander(pure) {
  var React = pure.React,
      defaults = pure.defaults;

  var wrapStyle = { display: 'flex',
    flexDirection: 'row',
    flexWrap: 'nowrap',
    flexGrow: 1,
    alignItems: 'center',
    justifyContent: 'space-around'
  };
  var expanderButtonStyle = { border: 0,
    backgroundColor: 'transparent',
    cursor: 'pointer'
  };

  var Expander = function Expander(props) {
    return React.createElement(
      'span',
      { style: wrapStyle },
      props.visible ? React.createElement(
        'span',
        null,
        React.createElement(
          'button',
          { style: expanderButtonStyle, onClick: props.handleExpand },
          React.createElement('i', { className: (0, _classnames2.default)('fa fa-' + (props.expanded ? 'minus' : 'plus') + '-square', props.theme.expander) })
        )
      ) : null
    );
  };
  return Expander;
}