'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = cards;

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _raf = require('raf');

var _raf2 = _interopRequireDefault(_raf);

var _grid = require('./grid');

var _grid2 = _interopRequireDefault(_grid);

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function cards(pure) {
  var React = pure.React,
      PropTypes = pure.PropTypes,
      cloneElement = pure.cloneElement,
      shallowCompare = pure.shallowCompare,
      Immutable = pure.Immutable,
      Pre = pure.Pre,
      formula = pure.formula,
      defaults = pure.defaults;


  var toggleHeight = 50;

  var Grid = (0, _grid2.default)(pure);
  var ZERO_MEASURES = [null, '', 0, '0', '0px', 50 + 'px'];

  return pure({ displayName: 'chart',
    propTypes: { styles: PropTypes.object.isRequired,
      theme: PropTypes.object.isRequired,
      data: PropTypes.object.isRequired,
      transitionDurationMS: PropTypes.number,
      minX: PropTypes.number.isRequired,
      minY: PropTypes.number.isRequired,
      maxX: PropTypes.number.isRequired,
      maxY: PropTypes.number.isRequired,
      preserveAspectRatio: PropTypes.string.isRequired
    },
    defaultProps: (0, _extends3.default)({}, defaults, { minX: -100,
      minY: -100,
      maxX: 100,
      maxY: 100,
      preserveAspectRatio: 'xMidYMid meet'
    }),
    init: function init() {
      this.contents = {};
    },
    render: function render() {
      var _props = this.props,
          styles = _props.styles,
          theme = _props.theme,
          mapDatum = _props.mapDatum,
          data = _props.data,
          minX = _props.minX,
          minY = _props.minY,
          maxX = _props.maxX,
          maxY = _props.maxY,
          preserveAspectRatio = _props.preserveAspectRatio,
          gridProps = (0, _objectWithoutProperties3.default)(_props, ['styles', 'theme', 'mapDatum', 'data', 'minX', 'minY', 'maxX', 'maxY', 'preserveAspectRatio']);

      var viewBox = minX + ' ' + minY + ' ' + (maxX - minX) + ' ' + (maxY - minY);
      return React.createElement(Grid, (0, _extends3.default)({}, gridProps, {
        data: data,
        templates: { Body: function Body(_ref) {
            var documentIndex = _ref.documentIndex,
                children = _ref.children,
                props = (0, _objectWithoutProperties3.default)(_ref, ['documentIndex', 'children']);
            return React.createElement(
              'svg',
              {
                className: (0, _classnames2.default)(styles.graph, theme.graph),
                viewBox: viewBox,
                preserveAspectRatio: preserveAspectRatio
              },
              React.createElement(
                'g',
                { className: (0, _classnames2.default)(styles.graphTransform, theme.graphTransform) },
                children
              )
            );
          },
          Document: pure.profile({ displayName: 'GraphDocument',
            render: function render(_ref2) {
              var documentIndex = _ref2.documentIndex,
                  children = _ref2.children,
                  props = (0, _objectWithoutProperties3.default)(_ref2, ['documentIndex', 'children']);

              return children;
            }
          })
        },
        mapDocument: function mapDocument(_ref3) {
          var documentIndex = _ref3.documentIndex,
              documentID = _ref3.documentID,
              datum = _ref3.datum;
          return mapDatum({ documentIndex: documentIndex, documentID: documentID, datum: datum });
        }
      }));
    }
  });
}