'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

exports.default = grid;

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _raf = require('raf');

var _raf2 = _interopRequireDefault(_raf);

var _shouldGridUpdate = require('./utils/shouldGridUpdate');

var _shouldGridUpdate2 = _interopRequireDefault(_shouldGridUpdate);

var _shouldDocumentUpdate = require('./utils/shouldDocumentUpdate');

var _shouldDocumentUpdate2 = _interopRequireDefault(_shouldDocumentUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function grid(pure) {
  var React = pure.React,
      PropTypes = pure.PropTypes,
      cloneElement = pure.cloneElement,
      shallowCompare = pure.shallowCompare,
      createFragment = pure.createFragment,
      Immutable = pure.Immutable,
      Pre = pure.Pre,
      formula = pure.formula,
      defaults = pure.defaults;
  var _defaults$styles = defaults.styles,
      styles = _defaults$styles === undefined ? {} : _defaults$styles,
      _defaults$theme = defaults.theme,
      theme = _defaults$theme === undefined ? {} : _defaults$theme;


  var Document = pure.impure({ displayName: 'GridDocument',
    shouldComponentUpdate: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _shouldDocumentUpdate2.default)(this, nextProps, nextState);
    },
    render: function render() {
      var _props = this.props,
          documentIndex = _props.documentIndex,
          children = _props.children,
          isHeader = _props.isHeader,
          isFooter = _props.isFooter,
          className = _props.className,
          props = (0, _objectWithoutProperties3.default)(_props, ['documentIndex', 'children', 'isHeader', 'isFooter', 'className']);

      var moduloStyle = typeof documentIndex === 'number' && documentIndex >= 0 ? documentIndex % 2 === 0 ? 'even' : 'odd' : null;
      return React.createElement(
        'div',
        (0, _extends3.default)({ className: selectStyles(['document', moduloStyle], className) }, props),
        children
      );
    }
  });

  /** Entire grid designed in templates to invert the control here. */
  var templatesShape = { Container: PropTypes.func,
    Header: PropTypes.func,
    Footer: PropTypes.func,
    ColumnHeader: PropTypes.func,
    ColumnFooter: PropTypes.func,
    Document: PropTypes.func,
    DocumentHeader: PropTypes.func,
    DocumentBody: PropTypes.func,
    DocumentFooter: PropTypes.func,
    Cell: PropTypes.func,
    CellHeader: PropTypes.func,
    CellFooter: PropTypes.func
  };

  var selectStyles = function selectStyles(styleNames, classNames) {
    return _classnames2.default.apply(undefined, (0, _toConsumableArray3.default)((Array.isArray(styleNames) ? styleNames : [styleNames]).map(function (styleName) {
      return [styles[styleName], theme[styleName]];
    })).concat([classNames ? Array.isArray(classNames) ? classNames : [classNames] : null]));
  };

  var defaultTemplates = { Container: function Container(_ref) {
      var children = _ref.children,
          className = _ref.className,
          props = (0, _objectWithoutProperties3.default)(_ref, ['children', 'className']);
      return React.createElement(
        'div',
        (0, _extends3.default)({ className: selectStyles('grid', className) }, props),
        children
      );
    },
    Header: function Header(_ref2) {
      var children = _ref2.children,
          props = (0, _objectWithoutProperties3.default)(_ref2, ['children']);
      return React.createElement(
        'div',
        { className: selectStyles('gridHeader') },
        children
      );
    },
    Body: function Body(_ref3) {
      var children = _ref3.children,
          props = (0, _objectWithoutProperties3.default)(_ref3, ['children']);
      return React.createElement(
        'div',
        { className: selectStyles('body') },
        children
      );
    },
    Footer: function Footer(_ref4) {
      var children = _ref4.children,
          props = (0, _objectWithoutProperties3.default)(_ref4, ['children']);
      return React.createElement(
        'div',
        { className: selectStyles('gridFooter') },
        children
      );
    },
    ColumnHeader: function ColumnHeader(_ref5) {
      var children = _ref5.children,
          props = (0, _objectWithoutProperties3.default)(_ref5, ['children']);
      return children
      /*
        <div className={selectStyles('columnHeader')}>
          {children}
        </div>
        */
      ;
    },
    ColumnFooter: function ColumnFooter(_ref6) {
      var children = _ref6.children,
          props = (0, _objectWithoutProperties3.default)(_ref6, ['children']);
      return children
      /*
        <div className={selectStyles('columnFooter')}>
          {children}
        </div>
        */
      ;
    },
    Document: Document /*: pure.impure (
                       { displayName: 'GridDocument'
                       , render
                       ({ documentIndex, children, isHeader, isFooter, className, ...props }) => {
                       const moduloStyle = typeof documentIndex === 'number' && documentIndex >= 0 ? (documentIndex % 2 === 0 ? 'even' : 'odd') : null
                       return (
                       <div className={selectStyles([ 'document', moduloStyle ], className)}>
                        {children}
                       </div>
                       )
                       }
                       }
                       )
                       */
    , DocumentHeader: function DocumentHeader(_ref7) {
      var children = _ref7.children,
          props = (0, _objectWithoutProperties3.default)(_ref7, ['children']);
      return React.createElement(
        'div',
        { className: selectStyles('documentHeader') },
        React.createElement(
          'span',
          { className: selectStyles('documentHeaderContent') },
          children
        )
      );
    },
    DocumentBody: function DocumentBody(_ref8) {
      var children = _ref8.children,
          documentIndex = _ref8.documentIndex,
          props = (0, _objectWithoutProperties3.default)(_ref8, ['children', 'documentIndex']);
      return React.createElement(
        'div',
        (0, _extends3.default)({ className: selectStyles('documentBody') }, props),
        children
      );
    },
    DocumentFooter: function DocumentFooter(_ref9) {
      var children = _ref9.children,
          props = (0, _objectWithoutProperties3.default)(_ref9, ['children']);
      return React.createElement(
        'div',
        { className: selectStyles('documentFooter') },
        React.createElement(
          'span',
          { className: selectStyles('documentFooterContent') },
          children
        )
      );
    },
    Cell: function Cell(_ref10) {
      var children = _ref10.children,
          props = (0, _objectWithoutProperties3.default)(_ref10, ['children']);
      return children
      /*
        <div className={selectStyles('cell')}>
          {children}
        </div>
        */
      ;
    },
    Fill: function Fill(_ref11) {
      var _ref11$children = _ref11.children,
          children = _ref11$children === undefined ? null : _ref11$children,
          props = (0, _objectWithoutProperties3.default)(_ref11, ['children']);
      return React.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)(selectStyles('fill')) }, props),
        children
      );
    },
    NoContent: function NoContent(props) {
      return React.createElement('div', props);
    }
  };

  /** Renders a flexbox based grid with Immutable data. */
  return pure.impure({ displayName: 'GridComponent',
    propTypes: { 'aria-label': PropTypes.string

      /** Optional inline style */
      , style: PropTypes.object

      /** Optional custom CSS class name to attach to root Grid element. */
      , className: PropTypes.string

      /** Optional custom CSS class for individual cells */
      , cellClassName: PropTypes.oneOfType([PropTypes.string, PropTypes.func])

      /** Optional custom styles for individual cells */
      , cellStyle: PropTypes.oneOfType([PropTypes.object, PropTypes.func])

      /**
       * Controls scroll-to-cell behavior of the Grid.
       * The default ("auto") scrolls the least amount possible to ensure that the specified cell is fully visible.
       * Use "start" to align cells to the top/left of the Grid and "end" to align bottom/right.
       */
      , scrollToAlignment: PropTypes.oneOf(['auto', 'end', 'start', 'center']).isRequired

      /** Column index to ensure visible (by forcefully scrolling if necessary) */
      , scrollToColumn: PropTypes.number

      /** Document index to ensure visible (by forcefully scrolling if necessary) */
      , scrollToDocument: PropTypes.number

      /** Tab index for focus */
      , tabIndex: PropTypes.number

      /** Optionally constrain grid to maximum height, otherwise expands to fill container (if enough documents rendered). */
      , maxHeight: PropTypes.number

      /** Optionally constrain grid to maximum width, otherwise uses containers width. */
      , maxWidth: PropTypes.number

      /**
       * Optional: Either a fixed row height (number) or a function that returns the height of a row given its index.
       * Should implement the following interface: ({ index: number }): number
       */
      , rowHeight: PropTypes.oneOfType([PropTypes.number, PropTypes.func])

      /**
       * Optional: Either a fixed column width (number) or a function that returns the width of a column given its index.
       * Should implement the following interface: (index: number): number
       */
      , columnWidth: PropTypes.oneOfType([PropTypes.number, PropTypes.func]),

      data: PropTypes.object.isRequired,
      mapDocument: PropTypes.oneOfType([PropTypes.func, PropTypes.object]),
      mapColumn: PropTypes.object,
      mapCell: PropTypes.func,
      templates: PropTypes.shape(templatesShape),
      styles: PropTypes.object.isRequired,
      theme: PropTypes.object.isRequired,
      mergeLocal: PropTypes.func.isRequired,
      useContentHeight: PropTypes.bool.isRequired,
      onDocumentClick: PropTypes.func
    },
    defaultProps: (0, _extends3.default)({ 'aria-label': 'grid',
      className: '',
      style: {},
      cellStyle: {},
      scrollToAlignment: 'auto',
      tabIndex: 0,

      templates: {},
      mapDocument: {},
      mapColumn: {},
      mergeLocal: function mergeLocal(_ref12) {
        var documentLocal = _ref12.documentLocal,
            columnLocal = _ref12.columnLocal;
        return (0, _assign2.default)({}, documentLocal, columnLocal);
      },
      useContentHeight: false
    }, defaults),
    state: { documentLocal: null,
      columnLocal: null
    },
    init: function init() {
      var _this = this;

      this._updateLocals = function () {
        var _props2 = _this.props,
            data = _props2.data,
            mapColumn = _props2.mapColumn,
            mapDocument = _props2.mapDocument;

        var columns = data.get('columns');
        var documents = data.get('documents');
        var columnLocal = columns && mapColumn.local ? columns.reduce(function (map, columnID) {
          return map.set(columnID, mapColumn.local(columnID));
        }, Immutable.Map()) : null;
        var documentLocal = mapDocument.local ? documents.keySeq().reduce(function (map, documentID) {
          return map.set(documentID, mapDocument.local(documentID));
        }, Immutable.Map()) : null;
        _this.setState({ columnLocal: columnLocal, documentLocal: documentLocal });
      };
    },
    componentWillMount: function componentWillMount() {
      this._updateLocals();
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
      if (this.props.data !== nextProps.data) this._updateLocals();
    },
    shouldComponentUpdate: function shouldComponentUpdate() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _shouldGridUpdate2.default.apply(undefined, [this].concat(args));
    },
    render: function render() {
      var _this2 = this;

      var _props3 = this.props,
          className = _props3.className,
          style = _props3.style,
          cellClassName = _props3.cellClassName,
          cellStyle = _props3.cellStyle,
          maxHeight = _props3.maxHeight,
          maxWidth = _props3.maxWidth,
          tabIndex = _props3.tabIndex,
          data = _props3.data,
          mapColumn = _props3.mapColumn,
          mapDocument = _props3.mapDocument,
          mapCell = _props3.mapCell,
          mergeLocal = _props3.mergeLocal,
          useContentHeight = _props3.useContentHeight,
          onDocumentClick = _props3.onDocumentClick,
          onCellClick = _props3.onCellClick,
          styles = _props3.styles,
          theme = _props3.theme;


      var templates = (0, _extends3.default)({}, defaultTemplates, this.props.templates);
      var documents = data.get('documents');

      var isPrimitive = typeof mapDocument === 'function';

      var columns = isPrimitive ? null : data.get('columns');

      var rendered = { columnHeader: mapColumn.header ? React.createElement(templates.ColumnHeader, { columnIndex: -1 }) : null,
        columnFooter: mapColumn.footer ? React.createElement(templates.ColumnFooter, { columnIndex: -1 }) : null,
        document: React.createElement(templates.Document, { documentIndex: -1 }),
        documentHeader: !isPrimitive && mapDocument && mapDocument.header ? React.createElement(templates.DocumentHeader, { documentIndex: -1 }) : null,
        documentFooter: !isPrimitive && mapDocument && mapDocument.footer ? React.createElement(templates.DocumentFooter, { documentIndex: -1 }) : null,
        documentBody: !isPrimitive && columns ? React.createElement(templates.DocumentBody, { documentIndex: -1 }) : null,
        cell: !isPrimitive && columns ? React.createElement(templates.Cell, { documentIndex: -1, columnIndex: -1 }) : null
      };

      var gridColumns = isPrimitive ? null : columns.map(function (columnID, columnIndex) {
        var local = _this2.state.columnLocal && _this2.state.columnLocal.get(columnID);
        var columnHeader = rendered.columnHeader,
            columnFooter = rendered.columnFooter;

        var header = columnHeader ? cloneElement(columnHeader, { key: columnIndex,
          columnIndex: columnIndex,
          children: mapColumn.header({ local: local, columnID: columnID, columnIndex: columnIndex })
        }) : null;
        var footer = columnFooter ? cloneElement(columnFooter, { key: columnIndex,
          columnIndex: columnIndex,
          children: mapColumn.footer({ local: local, columnID: columnID, columnIndex: columnIndex })
        }) : null;
        return { header: header, footer: footer };
      });

      /** TODO: MAKE 1 INSTANCE and clone with locals and data, test perf */
      var renderDocument = function renderDocument(_ref13) {
        var documentID = _ref13.documentID,
            documentIndex = _ref13.documentIndex,
            context = _ref13.context;

        var datum = context.get('datum');
        var cells = isPrimitive ? null : context.get('cells');
        var documentLocal = isPrimitive ? null : _this2.state.documentLocal && _this2.state.documentLocal.get(documentID);

        var children = isPrimitive ? mapDocument({ documentID: documentID,
          documentIndex: documentIndex,
          datum: datum
        }) : createFragment({ header: rendered.documentHeader ? cloneElement(rendered.documentHeader, { documentIndex: documentIndex,
            children: mapDocument.header({ local: documentLocal,
              documentID: documentID,
              documentIndex: documentIndex,
              datum: datum
            })
          }) : null,
          body: cloneElement(rendered.documentBody, { documentIndex: documentIndex,
            children: columns.map(function (columnID, columnIndex) {
              return cloneElement(rendered.cell, { key: columnIndex,
                documentIndex: documentIndex,
                columnIndex: columnIndex,
                children: cloneElement(mapCell({ documentIndex: documentIndex,
                  documentID: documentID,
                  columnIndex: columnIndex,
                  columnID: columnID,
                  local: mergeLocal({ documentLocal: documentLocal,
                    columnLocal: _this2.state.columnLocal && _this2.state.columnLocal.get(columnID)
                  }),
                  datum: cells.get(columnID)
                }), { onClick: function onClick(e) {
                    if (onCellClick) onCellClick({ documentIndex: documentIndex, documentID: documentID, columnIndex: columnIndex, columnID: columnID, datum: cells.get(columnID) });
                    return true;
                  }
                })
              });
            })
          }),
          footer: rendered.documentFooter ? cloneElement(rendered.documentFooter, { documentIndex: documentIndex,
            children: mapDocument.footer({ local: documentLocal,
              documentID: documentID,
              documentIndex: documentIndex,
              datum: datum
            })
          }) : null
        });

        return cloneElement(rendered.document, { key: documentIndex,
          documentIndex: documentIndex,
          children: children,
          onClick: function onClick(e) {
            if (onDocumentClick) onDocumentClick({ documentIndex: documentIndex, documentID: documentID });
            return true;
          },
          className: isPrimitive ? selectStyles('primitive') : selectStyles('sectional')
        });
      };

      return React.createElement(
        templates.Container,
        {
          ref: function ref(x) {
            return _this2.container = x;
          },
          style: style,
          className: (0, _classnames2.default)(className, selectStyles(useContentHeight ? 'fixedHeight' : 'variableHeight')),
          'aria-label': this.props['aria-label'],
          role: 'grid',
          tabIndex: tabIndex
        },
        this.props.header ? React.createElement(
          templates.Header,
          null,
          this.props.header
        ) : null,
        gridColumns && mapColumn.header ? cloneElement(rendered.document, { isHeader: true,
          children: gridColumns.map(function (columns) {
            return columns.header;
          })
        }) : null,
        React.createElement(
          templates.Body,
          { key: 'grid-body' },
          documents.entrySeq().map(function (_ref14, documentIndex) {
            var _ref15 = (0, _slicedToArray3.default)(_ref14, 2),
                documentID = _ref15[0],
                context = _ref15[1];

            return renderDocument({ documentID: documentID, documentIndex: documentIndex, context: context });
          }),
          React.createElement(templates.Fill, null)
        ),
        gridColumns && mapColumn.footer ? cloneElement(rendered.document, { isFooter: true,
          children: gridColumns.map(function (columns) {
            return columns.footer;
          })
        }) : null,
        this.props.footer ? React.createElement(
          templates.Footer,
          null,
          this.props.footer
        ) : null
      );
    }
  });
}